<?php

namespace Service;

class Balance {

    protected $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager){
        $this->entityManager = $entityManager;
    }

    public function getBalance($CDCLIENTE, $CDCONSUMIDOR, $CDFILIAL){
        $params = array(
            ':CDCLIENTE' => $CDCLIENTE,
            ':CDCONSUMIDOR' => $CDCONSUMIDOR,
            ':CDFILIAL' => $CDFILIAL
        );
        $result = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_BALANCE, $params);

        foreach ($result as &$familyBalance){
            $familyBalance['VRSALDCONFAM'] = sprintf("%.2f", $familyBalance['VRSALDCONFAM']);
            $familyBalance['VRSALDCONFAM'] = str_replace(".", ",", $familyBalance['VRSALDCONFAM']);
        }

        return $result;
    }

    public function checkBalance($CDCLIENTE, $CDCONSUMIDOR, $CDFAMILISALD){
        $params = array(
            ':CDCLIENTE' => $CDCLIENTE,
            ':CDCONSUMIDOR' => $CDCONSUMIDOR,
            ':CDFAMILISALD' => $CDFAMILISALD
        );
        $result = $this->entityManager->getConnection()->fetchAll(\Util\Query::CHECK_BALANCE, $params);
        return $result;
    }

    public function getConsumersBalance($CDCLIENTE, $NRCPFRESPCON){
        $params = array(
            ':CDCLIENTE' => $CDCLIENTE,
            ':NRCPFRESPCON' => $NRCPFRESPCON
        );
        $result = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_CONSUMERS_BALANCE, $params);

        foreach ($result as &$familyBalance){
            $familyBalance['VRSALDCONFAM'] = sprintf("%.2f", $familyBalance['VRSALDCONFAM']);
            $familyBalance['VRSALDCONFAM'] = str_replace(".", ",", $familyBalance['VRSALDCONFAM']);
        }

        return $result;
    }

    public function createBalance($CDCLIENTE, $CDCONSUMIDOR, $CDFAMILISALD, $VRSALDCONFAM){
        $params = array(
            ':CDCLIENTE' => $CDCLIENTE,
            ':CDCONSUMIDOR' => $CDCONSUMIDOR,
            ':CDFAMILISALD' => $CDFAMILISALD,
            ':VRSALDCONFAM' => $VRSALDCONFAM
        );
        $this->entityManager->getConnection()->executeQuery(\Util\Query::CREATE_BALANCE, $params);
    }

    public function updateBalance($CDCLIENTE, $CDCONSUMIDOR, $CDFAMILISALD, $VRSALDCONFAM){
        $params = array(
            ':CDCLIENTE' => $CDCLIENTE,
            ':CDCONSUMIDOR' => $CDCONSUMIDOR,
            ':CDFAMILISALD' => $CDFAMILISALD,
            ':VRSALDCONFAM' => $VRSALDCONFAM
        );
        $this->entityManager->getConnection()->executeQuery(\Util\Query::UPDATE_BALANCE, $params);
    }
    
    public function getBonusRecharge($CDFILIAL, $CDTIPOCONS, $CDTIPORECEORIGEM){
        $params = array(
            ':CDFILIAL' => $CDFILIAL,
            ':CDTIPOCONS' => $CDTIPOCONS,
            ':CDTIPORECEORIGEM' => $CDTIPORECEORIGEM
        );
        
        $result = $this->entityManager->getConnection()->fetchAssoc(\Util\Query::GET_BONUS_RECHARGE_ORIGIN, $params);
        
        /*if(empty($result)){
            $params = array(
                ':CDFILIAL' => $CDFILIAL,
                ':CDTIPOCONS' => $CDTIPOCONS
            );
            
            $result = $this->entityManager->getConnection()->fetchAssoc(\Util\Query::GET_BONUS_RECHARGE, $params);
        }*/
        
        return $result;
    }

}