<?php

namespace Service;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class EvoluiSaldo {

    protected $connection;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager){
        $this->connection = $entityManager->getConnection();
    }

    /*0*/
    public function EvoluiSaldoFunction(&$conditions){
        if (isset($conditions['CDCLIENTE'])){
            if (isset($conditions['CDCONSUMIDOR'])){
                if (isset($conditions['DTMOVEXTCONS'])){
                    if (isset($conditions['NRORG'])){
                        $allFamilies = $this->getSaldoAllFamilies($conditions);  //adqUltMovExtrato
                        foreach ($allFamilies as &$familie) {
                            $familie['DTMOVEXTCONS'] = $conditions['DTMOVEXTCONS'];
                            $forFamilie = $this->getSaldoForFamilie($familie);   //adqMovExtrato
                            foreach ($forFamilie as $key => &$valuesFamilie){
                                if ($key == 0){
                                    $this->CalculoSaldo($forFamilie[$key], $familie); //adqUltMovExtrato --> VRSALDCONEXT
                                }
                                $this->AtualizaMovimetacaoExtrato($forFamilie[$key], $key);
                                $SALDOFINAL = $forFamilie[$key]['SALDOFINAL'];
                                if (isset($forFamilie[$key+1])){
                                    $forFamilie[$key+1]['SALDOFINAL'] = $SALDOFINAL;
                                    $this->CalculoSaldoFinal($forFamilie[$key+1]);
                                }
                                $familie['SALDOFINAL'] = $SALDOFINAL;
                                if (!empty($familie)){
                                    $test = $this->GetVerificaSaldo($familie);
                                    if (empty($test)) {
                                       $this->InsertSaldoCons($familie);
                                    }
                                    else{
                                        $familie['NRORG'] = $conditions['NRORG'];
                                        $this->AtualizaSaldoCons($familie);
                                    }
                                }
                                else{
                                   return $arrayName = array();
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    /*1*/
    private function getSaldoAllFamilies($conditions){
        if ($conditions['CDCLIENTE'] == '')
            $conditions['TCDCLIENTE'] = 'T';
        else
            $conditions['TCDCLIENTE'] = ' ';
        if ($conditions['CDCONSUMIDOR'] == '')
            $conditions['TCDCONSUMIDOR'] = 'T';
        else
            $conditions['TCDCONSUMIDOR'] = ' ';
        $params = array(
            ':CDCLIENTE'    => $conditions['CDCLIENTE'],
            ':TCDCLIENTE'   => $conditions['TCDCLIENTE'],
            ':CDCONSUMIDOR' => $conditions['CDCONSUMIDOR'],
            ':TCDCONSUMIDOR'=> $conditions['TCDCONSUMIDOR'],
            ':DTMOVEXTCONS' => $conditions['DTMOVEXTCONS'],
            ':NRORG'        => $conditions['NRORG']
        );
        return $this->connection->fetchAll(\Util\Query::GET_SALDO_ALL_FAMILIES, $params);
    }

    /*2*/
    private function getSaldoForFamilie($conditions){
        $params = array(
            ':CDCLIENTE'    => $conditions['CDCLIENTE'],
            ':CDCONSUMIDOR' => $conditions['CDCONSUMIDOR'],
            ':CDFAMILISALD' => $conditions['CDFAMILISALD'],
            ':DTMOVEXTCONS' => $conditions['DTMOVEXTCONS'],
            ':NRORG'        => $conditions['NRORG']
        );
        return $this->connection->fetchAll(\Util\Query::GET_SALDO_FOR_FAMILIES, $params);
    }

    /*calculo 1 /*3*/
    private function CalculoSaldo(&$conditions, $familie){
        if ($conditions['IDTPMOVEXT'] == 'C'){
            $conditions['SALDOFINAL'] = floatval($familie['VRSALDCONEXT']) + floatval($conditions['VRMOVEXTCONS']);
        }
        else{
            $conditions['SALDOFINAL'] = floatval($familie['VRSALDCONEXT']) - floatval($conditions['VRMOVEXTCONS']);
        }
        return $conditions;
    }

    /*4*/
    private function AtualizaMovimetacaoExtrato($conditions, $key){
        $params = array(
            'SALDOFINAL'   =>  $conditions['SALDOFINAL'],
            'CDCLIENTE'    =>  $conditions['CDCLIENTE'],
            'CDCONSUMIDOR' =>  $conditions['CDCONSUMIDOR'],
            'CDFAMILISALD' =>  $conditions['CDFAMILISALD'],
            'DTMOVEXTCONS' =>  $conditions['DTMOVEXTCONS'],
            'NRSEQMOVEXT'  =>  $conditions['NRSEQMOVEXT'],
            'NRORG'        =>  $conditions['NRORG']
        );

        //$params['DTMOVEXTCONS'] = \DateTime::createFromFormat('Y-m-d H:i:s', $params['DTMOVEXTCONS']);
        return $this->connection->executeQuery(\Util\Query::ATUALIZA_MOVIMENTACAO_EXTRATO, $params);
    }

    /*calculo 2 /*5*/
    private function CalculoSaldoFinal(&$conditions){
        if ($conditions['IDTPMOVEXT'] == 'C'){
            $conditions['SALDOFINAL'] = floatval($conditions['SALDOFINAL']) + floatval($conditions['VRMOVEXTCONS']);
        } else {
            $conditions['SALDOFINAL'] = floatval($conditions['SALDOFINAL']) - floatval($conditions['VRMOVEXTCONS']);
        }
        return $conditions;
    }

    /*6*/
    private function GetVerificaSaldo($conditions) {
        $params = array(
            ':CDCLIENTE'    => $conditions['CDCLIENTE'],
            ':CDCONSUMIDOR' => $conditions['CDCONSUMIDOR'],
            ':CDFAMILISALD' => $conditions['CDFAMILISALD'],
            ':NRORG'        => $conditions['NRORG']
        );
        return $this->connection->fetchAll(\Util\Query::GET_VERIFICA_SALDO, $params);
    }

    /*7*/
    private function InsertSaldoCons($conditions) {
        $params = array(
            ':CDCLIENTE'    => $conditions['CDCLIENTE'],
            ':CDCONSUMIDOR' => $conditions['CDCONSUMIDOR'],
            ':CDFAMILISALD' => $conditions['CDFAMILISALD'],
            ':VRSALDCONFAM' => $conditions['SALDOFINAL'],
            ':NRORG'        => $conditions['NRORG']
        );
        return $this->connection->executeQuery(\Util\Query::INSERT_SALDO_CONS, $params);
    }

    /*8*/
    private function AtualizaSaldoCons($conditions) {
        $params = array(
            ':CDCLIENTE'     => $conditions['CDCLIENTE'],
            ':CDCONSUMIDOR'  => $conditions['CDCONSUMIDOR'],
            ':CDFAMILISALD'  => $conditions['CDFAMILISALD'],
            ':VRSALDCONFAM'  => $conditions['SALDOFINAL'],
            ':NRORG'         => $conditions['NRORG']
        );
        return $this->connection->executeQuery(\Util\Query::ATUALIZA_SALDO_CONS, $params);
    }

    public function getConsumerNrorg($CDCLIENTE, $CDCONSUMIDOR){
        $params = array(
            ':CDCLIENTE' => $CDCLIENTE,
            ':CDCONSUMIDOR' => $CDCONSUMIDOR
        );
        return $this->connection->fetchAssoc(\Util\Query::GET_CONSUMER_NRORG, $params);
    }
    
    //to use with procedure
    public function getTransactionDate($recalcParam, $CDCLIENTE, $CDCONSUMIDOR, $CDFAMILISALD = null){
        if($recalcParam === 'F'){
            $params = array(
                ':CDCLIENTE' => $CDCLIENTE,
                ':CDCONSUMIDOR' => $CDCONSUMIDOR
            );
            return $this->connection->fetchAssoc(\Util\Query::GET_TRANSACTION_DATE_F, $params);
        } else if($recalcParam === 'P'){
            $params = array(
                ':CDCLIENTE' => $CDCLIENTE,
                ':CDCONSUMIDOR' => $CDCONSUMIDOR,
                ':CDFAMILISALD' => $CDFAMILISALD
            );
            return $this->connection->fetchAssoc(\Util\Query::GET_TRANSACTION_DATE_P, $params);
        }
    }

    public function recalculateBalance($CDCLIENTE, $CDCONSUMIDOR, $CDFAMILISALD, $DTMOVEXTCONS){
        $procedure = new StoredProcedure($this->connection, 'ATUALIZA_SALDO_CONS_FKB');
        $procedure->addParam(new Param('CDCLIENTE', Param::PARAM_INPUT , $CDCLIENTE, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('CDCONSUMIDOR', Param::PARAM_INPUT, $CDCONSUMIDOR, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('CDFAMILISALD', Param::PARAM_INPUT, $CDFAMILISALD, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('DTMOVEXTCONS', Param::PARAM_INPUT, $DTMOVEXTCONS, Param::PARAM_TYPE_STR));
        $procedure->execute();
    }

}