<?php

namespace Service;

class PriceService {

    protected $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function getPrices($CDFILIAL, $CDTABEPREC, $DTINIVGPREC){
        $params = array(
            ':CDFILIAL' => $CDFILIAL,
            ':CDTABEPREC' => $CDTABEPREC,
            ':DTINIVGPREC' => $DTINIVGPREC,
        );
        
        return $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_PRICES, $params);
    }

    public function clientBranchPricingTable($CDCLIENTE, $CDFILIAL){
        $params = array(
            ':CDCLIENTE' => $CDCLIENTE,
            ':CDFILIAL' => $CDFILIAL
        );
        $result = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_CLIENTBRANCH_PRICING_TABLE, $params);
        return !Empty($result[0]['CDTABEPREC']) ? $result[0] : array();
    }

    public function clientPricingTable($CDCLIENTE){
        $params = array(
            ':CDCLIENTE' => $CDCLIENTE
        );
        $result = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_CLIENT_PRICING_TABLE, $params);
        return !Empty($result[0]['CDTABEPREC']) ? $result[0] : array();
    }

    public function storePricingTable($CDFILIAL, $CDLOJA){
        $params = array(
            ':CDFILIAL' => $CDFILIAL,
            ':CDLOJA' => $CDLOJA
        );
        $result = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_STORE_PRICING_TABLE, $params);
        return !Empty($result[0]['CDTABEPREC']) ? $result[0] : array();
    }

    public function paravendPricingTable($CDFILIAL){
        $params = array(
            ':CDFILIAL' => $CDFILIAL
        );
        $result = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_PARAVEND_PRICING_TABLE, $params);
        return !Empty($result[0]['CDTABEPREC']) ? $result[0] : array();
    }

    public function getSalesTable($CDFILIAL, $CDTABEPREC){
        $params = array(
            ':CDFILIAL' => $CDFILIAL,
            ':CDTABEPREC' => $CDTABEPREC
        );

        $result = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_SALES_TABLE, $params);
        return !Empty($result) ? $result[0] : $result;
    }

    public function getItemPrice($CDFILIAL, $CDTABEPREC, $DATAVIG, $CDPRODUTO){
        $params = array(
            ':CDFILIAL' => $CDFILIAL,
            ':CDTABEPREC' => $CDTABEPREC,
            ':DATAVIG' => $DATAVIG,
            ':CDPRODUTO' => $CDPRODUTO
        );
        $result = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_ITEM_PRICE, $params);
        return !Empty($result) ? $result[0] : $result;
    }

    public function holidayCheck($CDFILIAL, $DTFERIFILI){
        $params = array(
            ':CDFILIAL' => $CDFILIAL,
            ':DTFERIFILI' => $DTFERIFILI
        );
        $result = $this->entityManager->getConnection()->fetchAll(\Util\Query::HOLIDAY_CHECK, $params);
        return !Empty($result) ? $result[0] : $result;
    }

    public function getDailyPrice($CDFILIAL, $CDTABEPREC, $DTINIVGPREC, $CDPRODUTO, $day, $hour){
        $params = array(
            ':CDFILIAL'     => $CDFILIAL,
            ':CDTABEPREC'   => $CDTABEPREC,
            ':DTINIVGPREC'  => $DTINIVGPREC,
            ':CDPRODUTO'    => $CDPRODUTO,
            ':CDPRPAITABPR' => $CDPRODUTO,
            ':NRDIASEMANPR' => $day,
            ':CDTIPOCONSPD' => 'T',
            ':HORA'         => $hour
        );
        $result = $this->entityManager->getConnection()->fetchAll(\Util\Query::ITEM_DAY_PRICE, $params);
        return !Empty($result) ? $result[0] : $result;
    }

}