<?php

namespace Zeedhi\PaymentPlatform\examples;

$ds = DIRECTORY_SEPARATOR;

require_once __DIR__.$ds.'..'.$ds.'..'.$ds.'vendor'.$ds.'autoload.php';

use Zeedhi\PaymentPlatform\Implementations\Cielo\PaymentImpl;
$paymentPlatform = PaymentImpl::factory(
    "FFXPQEDSNSWPQCMWBYSEXSEAVOMGDJOMWQKGRQPL",
    "67466780-45be-4cb7-b72f-7529c520d146",
    PaymentImpl::SANDBOX
 );

use Zeedhi\PaymentPlatform\NonInstantBuy\NonInstantBuyPlatform;
use Zeedhi\PaymentPlatform\NonInstantBuy\NonInstantBuyTransaction;

use Zeedhi\PaymentPlatform\Address;
use Zeedhi\PaymentPlatform\Customer;
use Zeedhi\PaymentPlatform\CreditCard;

class Order {

    private $paymentPlatform;

    public function __construct(NonInstantBuyPlatform $paymentPlatform) {
        $this->paymentPlatform = $paymentPlatform;
    }

    public function createOrder($value, $transactionId, CreditCard $creditCard, Customer $customer){
        $transaction = new NonInstantBuyTransaction($value, $transactionId, $creditCard, $customer);
        $nit = $this->paymentPlatform->nonInstantBuyTransaction($transaction);
        var_dump($nit);
        $order = $this->paymentPlatform->captureTransaction($nit['captureUrl'], $nit['paymentId']);
        var_dump($order);
    }
}

$customer = new Customer();
$holderName = "Stephen Vincent Strange";
$numbers = "0000000000000001";
$expDateMonth = "12";
$expDateYear = "2018";
$cvv = "123";
$flag = "Visa";
$creditCard = new CreditCard($holderName, $numbers, $expDateMonth, $expDateYear, $cvv, $flag);

$value = "1000"; 
$transactionId = "0666";

$order = new Order($paymentPlatform);
$transactionKey = $order->createOrder($value, $transactionId, $creditCard, $customer);
