<?php
namespace Zeedhi\PaymentPlatform\NonInstantBuy;

use Zeedhi\PaymentPlatform\Transaction;
use Zeedhi\PaymentPlatform\CreditCard;
use Zeedhi\PaymentPlatform\Customer;

class NonInstantBuyTransaction extends Transaction {

    /** @var CreditCard */
    private $creditCard;
    /** @var Customer */
    private $customer;
    
    /**
     * @param float         $value
     * @param string        $transactionId
     * @param CreditCard    $creditCard
     * @param Customer      $customer
     */
    public function __construct($value, $transactionId, CreditCard $creditCard, Customer $customer, $nrInstallment = 1) {
        parent::__construct($value, $transactionId, $nrInstallment);
        $this->creditCard = $creditCard;
        $this->customer = $customer;
    }

    /**
     * @return CreditCard
     */
    public function getCreditCard() {
        return $this->creditCard;
    }
    
    /**
     * @return Customer
     */
    public function getCustomer() {
        return $this->customer;
    }

    public function setItems($items) {
        $this->items = $items;
    }

    /**
     * @return Items
     */
    public function getItems() {
        return $this->items;
    }

}