<?php
namespace Zeedhi\PaymentPlatform;

abstract class RequestURL {
    
    const MUNDIPAGG_CUSTOMERS = "customers";
    const MUNDIPAGG_CARDS = "cards";
    const MUNDIPAGG_CHARGES = "charges";

    const CIELO_SALES = "/1/sales";
    const CIELO_CARDS = "/1/card";

    const PAGARME_TRANSACTIONS = "/1/transactions";
    const PAGARME_CARDS = "/1/cards";
    const PAGARME_CAPTURE = "/capture";

    const BRASPAG_SALES = "/v2/sales/";

    const SOFTWAREEXPRESS_TRANSACTIONS = '/v1/transactions';
    const SOFTWAREEXPRESS_PAYMENTS = '/v1/payments';
    const SOFTWAREEXPRESS_CARDS = "/v1/cards";

    /** @var string */
    private $id;
    /** @var string */
    private $baseURL;

    /**
     * @param string  $id
     * @param string $baseURL
     */
    public function __construct($id, $baseURL) {
        $this->id = $id;
        $this->baseURL = $baseURL;
    }

    /**
     * @return string
     */
    public function getId() {
        return $this->id;
    }
    
    /**
     * @return string
     */
    public function getBaseURL() {
        return $this->baseURL;
    }

}