<?php
namespace Zeedhi\PaymentPlatform;

class CreditCardTest extends \PHPUnit_Framework_TestCase {

	/** @var CreditCard */
	protected $creditCard;
	/** @var String */
	protected $holderName = "TEKNISA TESTES";
	/** @var String */
	protected $numbers = "4000000000000001";
	/** @var String */
	protected $expDateMonth = "03";
	/** @var String */
	protected $expDateYear = "20";
	/** @var String */
	protected $cvv = "000";
	/** @var String */
	protected $flag = "Visa";

	public function setUp(){
		$this->creditCard = new CreditCard($this->holderName, $this->numbers, $this->expDateMonth, $this->expDateYear, $this->cvv, $this->flag);
	}
	
	public function testGetHolderName() {
        $this->assertEquals($this->holderName, $this->creditCard->getHolderName());
    }
	
	public function testGetNumbers() {
        $this->assertEquals($this->numbers, $this->creditCard->getNumbers());
    }
	
	public function testGetExpDateMonth() {
        $this->assertEquals($this->expDateMonth, $this->creditCard->getExpDateMonth());
    }
	
	public function testGetExpDateYear() {
        $this->assertEquals($this->expDateYear, $this->creditCard->getExpDateYear());
    }
	
	public function testGetCvv() {
        $this->assertEquals($this->cvv, $this->creditCard->getCvv());
    }
	
	public function testGetFlag() {
        $this->assertEquals($this->flag, $this->creditCard->getFlag());
    }
}