<?php
namespace Zeedhi\Framework\ORM;

use Doctrine\Common\EventManager;
use Doctrine\DBAL\Configuration;
use Doctrine\DBAL\DriverManager;

/**
 * Class Connection Factory
 * 
 * Class used to connect to encrypted databases.
 * 
 * @package Zeedhi\Framework\ORM
 * 
 * @version 1.0.0
 * 
 * @deprecated Since version 1.0.0 for security reasons.
 */
class ConnectionFactory {

    protected static function getSalt() {
        return str_pad("zeedhi", 32, "\0");
    }

    /**
     * Encrypt.
     *
     * @param string $text Text.
     *
     * @return string
     */
    public static function encrypt($text)
    {
        return trim(
            base64_encode(
                mcrypt_encrypt(
                    MCRYPT_RIJNDAEL_256,
                    self::getSalt(),
                    $text,
                    MCRYPT_MODE_ECB,
                    mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), MCRYPT_RAND)
                )
            )
        );
    }


    /**
     * Decrypt.
     *
     * @param string $text Text.
     *
     * @return string
     */
    public static function decrypt($text)
    {
        return trim(
            mcrypt_decrypt(
                MCRYPT_RIJNDAEL_256,
                self::getSalt(),
                base64_decode($text),
                MCRYPT_MODE_ECB,
                mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), MCRYPT_RAND)
            )
        );
    }

    /**
     * @param array         $connectionParams
     * @param Configuration $config
     * @param EventManager  $eventManager
     *
     * @return \Doctrine\DBAL\Connection
     *
     * @throws \Doctrine\DBAL\DBALException
     */
    public static function factoryWithEncryptedPassword(array $connectionParams, $config = null, $eventManager = null) {
        $connectionParams["password"] = self::decrypt($connectionParams["password"]);
        return DriverManager::getConnection($connectionParams, $config, $eventManager);
    }
}