<?php
namespace Zeedhi\PaymentPlatform;

abstract class Transaction {

    /** @var float */
    private $value;
    /** @var string */
    private $transactionId;
    /** @var int */
    private $nrInstallment;

    /**
     * @param float  $value
     * @param string $transactionId
     * @param int    $nrInstallment
     */
    public function __construct($value, $transactionId, $nrInstallment = 1) {
        $this->value = $value;
        $this->transactionId = $transactionId;
        $this->nrInstallment = $nrInstallment;
    }

    /**
     * @return float
     */
    public function getValue() {
        return $this->value;
    }
    
    /**
     * @return string
     */
    public function getTransactionId() {
        return $this->transactionId;
    }

    /**
     * @return int
     */
    public function getNrInstallment() {
        return $this->nrInstallment;
    }



}