describe("EventHandler", function () {
    var zhLogger = new Logger();
    var eventHandler = new EventHandler({}, {}, zhLogger);
    
    it("EventHandler.notify: should call ZhLogger.error when the there is an exception", function () {
        spyOn(zhLogger, 'error').and.callThrough();
        
        eventHandler.notify({method: function () { throw new Message("Error"); }});
        expect(zhLogger.error).toHaveBeenCalled();
    });
    
    it("EventHandler.notify: should call evt.request when there is no method", function () {
        var evt = {request: function () {}};
        spyOn(evt, 'request').and.callThrough();
        
        eventHandler.notify(evt);
        expect(evt.request).toHaveBeenCalled();
    });
});