var FilterFloatingCardController = (function(_super) {
	__extends(FilterFloatingCardController1, _super);

	function FilterFloatingCardController1($scope, $rootScope, ScreenService, templateManager, ApplicationContext, restEngine, ZHPromise, eventAggregator, $timeout, ZhKeyboardService) {
		var _ref = FilterFloatingCardController.__super__.constructor.apply(this, arguments);

		var zhFilterPreferences = ApplicationContext.zhFilterPreferences;

		function getFilterFromSearchCriteria(filters, searchCriteria) {
			// remove itens starting with "SEARCHLIST_"
			filters = (filters || []).filter(function(filter) {
				return !~filter.name.indexOf("SEARCHLIST_");
			});
			if (searchCriteria) {			
				Object.keys(searchCriteria).forEach(function(key) {
					if (searchCriteria[key]) {				
						filters.push({
							name: "SEARCHLIST_"+key,
							operator: "LIKE",
							value: '%'+searchCriteria[key]+'%'
						});
					}
				});
			}
			return filters;
		}

		$scope.$watchCollection(function() { return $scope.widget.searchCriteria; }, function(current, old) {
			var newFilterApplied = getFilterFromSearchCriteria($scope.widget.filterApplied, current);
			if (!angular.equals($scope.widget.filterApplied, newFilterApplied)) {
				if ($scope.widget.customizationsApplied) {
					delete $scope.widget.customizationsApplied.filter;
				}

				$scope.widget.filterApplied = newFilterApplied;
				zhFilterPreferences.updateFilterInfo($scope.widget, newFilterApplied);
			}
		});

		$scope.clearSearch = function(event, fieldName) {
			if (!fieldName) {
				$scope.widget.searchCriteria = {};
			} else {
				delete $scope.widget.searchCriteria[fieldName];				
			}

			if (event) {
				Util.selectElement($(event.target).closest(".floating-card-input").find("input"));
			}
		};

		$scope.startFiltering = function() {
			zhFilterPreferences.startFiltering($scope.widget);
		};
		$scope.$on('control-info-icon-click', function(event, data) {
			if (data == 'filter') {
				$scope.startFiltering();
			} else {
				$scope.clearSearch();
			}
		});

		$scope.isSearchFieldSelect = function(field) {
			return field && ((field.filterProperties && field.filterProperties.template && ~field.filterProperties.template.indexOf('select-native.html')) || 
							 (field.template && ~field.template.indexOf('select-native.html')));
		};

		$scope.prepareField = function(field) {
			return zhFilterPreferences.prepareFields(Util.parseToArray(field))[0];
		};

		function isMobiScrollOpen() {
			return $('.mbsc-mobiscroll').length > 0;
		}

		$scope.openWidgetFilter = function(event, key) {
			if (!ScreenService.isSideMenuOpen() && !isMobiScrollOpen() && !ScreenService.isAlertShown()) {
				var widget = angular.element('.zh-floating-control:last').scope().widget;
				if (widget.floatingControl && widget.floatingControl.customizationAction && widget.floatingControl.customizationAction.filter) {
					ApplicationContext.zhFilterPreferences.startFiltering(widget);
				}
			}

			// prevent default behaviour
			return false;
		};

		$scope.openWidgetSearch = function(event, key) {
			if (!ScreenService.isSideMenuOpen() && !isMobiScrollOpen() && !ScreenService.isAlertShown()) {
				var scope = angular.element('.zh-floating-control:last').scope();
				scope.openSearchAction();
			}

			// prevent default behaviour
			return false;
		};

		$scope.initKeyboardShortCuts = function() {
			ZhKeyboardService.unbind(templateManager.project.shortcutKeys.openWidgetFilter || 'mod+l');
			ZhKeyboardService.unbind(templateManager.project.shortcutKeys.openWidgetSearch || 'mod+f');
			
			ZhKeyboardService.bind(templateManager.project.shortcutKeys.openWidgetFilter || 'mod+l', $scope.openWidgetFilter);
			ZhKeyboardService.bind(templateManager.project.shortcutKeys.openWidgetSearch || 'mod+f', $scope.openWidgetSearch);
		};
		$scope.initKeyboardShortCuts();

		return _ref;
	}

	return FilterFloatingCardController1;
})(CustomizationsFloatingCardController);