function CardapioController(Query, AccountCart, ScreenService, CardapioService, ProductsRepository, ObservationsRepository, Utilities, ScheduleFlagRepository, PriceRepository, LoginRepository, HistoryDetailsRepository, StoreListRepository, MenuCartRepository, templateManager, PlacesRepository){

    var self = this;

    this.verifyStore= function (widget){
        Utilities.setIps().then(function (){
            CardapioService.getStores().then(function (lojas){
                self.storeOpen(lojas, widget);
            });
        });
    }

    this.storeOpen= function (row, widget){
        ProductsRepository.clearAll().then(function (){
            CardapioService.loadProducts(row[0].CDFILIAL, row[0].CDLOJA, row[0].CDCAIXA, null, Utilities.imageUrl).then(function (){
                self.setScheduleFlagToFalse();
                self.loadMenu(widget);
            }.bind(this));
       }.bind(this));
    }

    this.setScheduleFlagToFalse = function(){
        ScheduleFlagRepository.save({'TOSCHEDULE': false});
    };

    /*
    this.loadMenu = function(productsWidget){
        ProductsRepository.findAll().then(function (products){
            MenuCartRepository.findAll().then(function (menuCart){
                productsWidget.shoppingCart.items = menuCart;
                productsWidget.dataSource.data = products;
            });
        });
    };
    */

    this.loadProductDetails = function(productWidget){
        productWidget.productItem.detailPages = [];
        CardapioService.loadGrupProd(productWidget.productItem.CDPRODUTO).then(function(grupos){
            grupos.forEach(function(grupoAtual){
                PriceRepository.findAll().then(function(prices){
                    var dados = prices[0];
                    CardapioService.loadProdGrup(grupoAtual.CDPRODPROMOCAO, grupoAtual.CDGRUPROMOC, productWidget.productItem.CDFILIAL, dados[grupoAtual.CDPRODPROMOCAO].CDTABEPREC, dados[grupoAtual.CDPRODPROMOCAO].DTINIVGPREC).then(function(itens){
                        itens.forEach(function(item){
                            item.price = parseFloat(item.PRICE);
                            item[productWidget.parentWidget.observationDescriptionField] = item.NOME;
                            item[productWidget.parentWidget.observationCodeField] = item.CDPRODUTO;
                            item.DESCRIPTION = null;
                            item.SHOWDETAILS = "0";
                        })
                        productWidget.productItem.detailPages.push({
                            title: grupoAtual.NMGRUPROMOC,
                            constraints: {
                                minSelection: grupoAtual.QTPRGRUPPROMOC,
                                maxSelection: grupoAtual.QTPRGRUPPROMOC
                            },
                            items: itens
                        });
                    });
                });
            });
        }.bind(this));
        this.loadProductObs(productWidget);
    };

    this.loadProductObs = function (productWidget){
        var query = Query.build().where('CDPRODUTO').equals(productWidget.productItem.CDPRODUTO);
        ObservationsRepository.find(query).then(function (obs){
            productWidget.productItem.detailPages = [];
            productWidget.productItem.detailPages.push({
                title: "observações",
                constraints: {
                    minSelection: 0
                },
                items: obs
            });
        });
    };

    this.checkCart = function(widget){
        var trueProducts = [];
        var qtty = 1;
        var products = Util.clone(widget.shoppingCart.items);
        if (products.length){
            //A pedido de Lucas Rodrigues e Luiz Baldi
            MenuCartRepository.save(products).then(function (){
            //O labirinto abaixo se trata de transformar produtos combinados em produtos separados
            for(var i = 0; i < products.length; i++){
                if(products[i].selectedPage.items){
                    products[i].selectedPage.items = [];
                }
                //apos varrer os produtos ele verifica se possui pagina de detalhes na qual possui os produtos dos grupos combinados
                if (products[i].detailPages) {
                    //infelizmente possui um array de array de array causando um "inception"
                    for(var j = 0; j < products[i].detailPages.length; j++){
                        if(products[i].detailPages[j].items){
                            products[i].detailPages[j].items = [];
                        }
                        //nesse momento ele começa a varrer cada pagina de detalhes de cada produto
                        if (products[i].detailPages[j].title !== "observações") {
                            //E so entra em pagina de produtos evitando a pagina de observações
                            //(Note que a pagina de observação e sempre criada mesmo que nao exista observação para o produto)
                            for (var k = products[i].detailPages[j].selectItems.length-1; k > -1;  k--) {
                                //agora ele começa a varrer as paginas de produtos dentro da pagina de detalhes e criar uma variavel de quantidade que la na frente e validada para ver o preço
                                products[i].detailPages[j].selectItems[k].qtty = 1;
                                trueProducts.push(products[i].detailPages[j].selectItems[k]);
                                //Cria-se um array separada para sair dessa "inception" e para passar para o array de produtos
                                products[i].detailPages[j].selectItems.pop();
                            }
                        }
                        //E infelizmente o Back valida as observações logo o produto da promoção combinada precisa dessas objervações.
                        for (var m = 0; m < trueProducts.length; m++) {
                            if (!trueProducts[m].detailPages || trueProducts[m].detailPages === undefined){
                                trueProducts[m].detailPages = products[i].detailPages
                            }
                        }
                    }
                }
            };
            //Alguma Duvida caso sim entre em contato no seguinte endereço br.answers.yahoo.com/
            for (var l = 0; l < trueProducts.length; l++) {
                products.push(trueProducts[l])
            };

            for (var i in products){
                products[i].LABELPRICE = products[i].qtty + ' x ' + products[i].PRICE.toFixed(2).replace('.', ',');
            }
            AccountCart.save(products).then(function (){
                    ScreenService.openWindow('orderCheck');
            });
        });
        }
        else {
            ScreenService.showMessage('Favor escolher pelo menos um produto antes de continuar.');
        }
    };

    this.setDatasource = function(widget) {
        widget.dataSource.data = [];
		PlacesRepository.findAll().then(function(places) {
            widget.dataSource.data = places;
            templateManager.updateTemplate();
		});
    };

    this.openMenu = (row) => {
		if (row.CDFILIAL !== undefined) {
            CardapioService.setSelectStore(row);
            ScreenService.openWindow('storeMenu');
		} else {
			ScreenService.showMessage('Selecione um restaurante para prosseguir.');
		}
    };
    
    this.loadMenu = function(widget) {
		const selectStore = CardapioService.getSelectStore();
		widget.menuProducts = [];
		widget.personalizations = [];
		LoginRepository.findOne().then(function (consumerData){
            CardapioService.loadMenu(selectStore, consumerData.CDCLIENTE)
            .then(function(response){
                widget.menuProducts = response[0].cardapio;
            })
        });
	};
}

Configuration(function(ContextRegister){
    ContextRegister.register('CardapioController', CardapioController);
});
